/*
 *	Copyright: Torquil Gault (tag@scatha.apana.org.au), 1998+
 *
 */

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;

import javax.swing.*;
import javax.swing.tree.*;

public class HierApplet extends JApplet {

	public URL HierCodeBase;

      	public Frame HierParent;

	public static int SCREEN_X = 640, SCREEN_Y = 255;

	public JScrollPane ScrollPane;
	public JTree HierTree;
	public DefaultMutableTreeNode rootNode, childNode;
	public DefaultTreeModel treeModel;
	public TreeNode treeNode, parentNode;
	public TreePath treePath;
	public HierarchyItem hierarchyItem;

	public JPanel Panel;
	public JButton[] Buttons;
	public JLabel[] Label;
	public JTextField[] TextField;

	int i;

	public HierApplet() {
	}

	public void start(String[] args) {
	}

	public void init() {
		HierParent = getFrame();
		setScreenPosition();
		HierParent.setSize(SCREEN_X,SCREEN_Y);

		try {
		   HierCodeBase = getCodeBase();
		} catch (Exception e) {
		   try {
			HierCodeBase = new URL("file", "", ".");
		   } catch (Exception e1) { ; }
		}
		System.out.println("Running in: " + System.getProperty("browser") +
			" (" + System.getProperty("os.name") + ") in Dir = " 
			+ System.getProperty("user.dir"));

		getContentPane().setLayout(new GridLayout(1,2,3,3));

		rootNode =  new DefaultMutableTreeNode("RootNode");
		treeModel =  new DefaultTreeModel(rootNode);
		HierTree = new JTree(treeModel);
		HierTree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
		HierTree.setEditable(true);
		ScrollPane = new JScrollPane(HierTree);

		Panel = new JPanel();
		QDCGridLayout qdcGL = new QDCGridLayout(20,20,5,5);
		Panel.setLayout(qdcGL);

		Buttons = new JButton[7];
		Buttons[0] = new JButton("Insert");
		Buttons[1] = new JButton("Move Up");
		Buttons[2] = new JButton("Move Down");
		Buttons[3] = new JButton("Remove");
		Buttons[4] = new JButton("Generate");
		Buttons[5] = new JButton("Load");
		Buttons[6] = new JButton("Save");
		Label = new JLabel[2];
		Label[0] = new JLabel("Identifier");
		Label[1] = new JLabel("Description");
		TextField = new JTextField[2];
		TextField[0] = new JTextField(10);
		TextField[1] = new JTextField(30);
		Panel.add(Label[0]); 
		qdcGL.setConstraint(Label[0], new QDCGridLayoutConstraint(0,1,5,2));
		Panel.add(Label[1]); 
		qdcGL.setConstraint(Label[1], new QDCGridLayoutConstraint(0,3,5,2));
		Panel.add(TextField[0]);
		qdcGL.setConstraint(TextField[0], new QDCGridLayoutConstraint(5,1,6,2));
		Panel.add(TextField[1]);
		qdcGL.setConstraint(TextField[1], new QDCGridLayoutConstraint(5,3,17,2));
		Panel.add(Buttons[0]); 
		qdcGL.setConstraint(Buttons[0], new QDCGridLayoutConstraint(3,7,7,3));
		Panel.add(Buttons[1]); 
		qdcGL.setConstraint(Buttons[1], new QDCGridLayoutConstraint(3,10,7,3));
		Panel.add(Buttons[2]); 
		qdcGL.setConstraint(Buttons[2], new QDCGridLayoutConstraint(3,13,7,3));
		Panel.add(Buttons[3]); 
		qdcGL.setConstraint(Buttons[3], new QDCGridLayoutConstraint(3,16,7,3));
		Panel.add(Buttons[4]); 
		qdcGL.setConstraint(Buttons[4], new QDCGridLayoutConstraint(11,7,7,3));
		Panel.add(Buttons[5]); 
		qdcGL.setConstraint(Buttons[5], new QDCGridLayoutConstraint(11,10,7,3));
		Panel.add(Buttons[6]); 
		qdcGL.setConstraint(Buttons[6], new QDCGridLayoutConstraint(11,13,7,3));

		Buttons[0].addMouseListener(new MouseAdapter() {		// Insert
		   public void mouseClicked(MouseEvent e) {
// System.out.println(((JButton )e.getComponent()).getText());
			treePath = HierTree.getSelectionPath();
			if (treePath == null)
			   treeNode = rootNode;
			else
			   treeNode = (DefaultMutableTreeNode )treePath.getLastPathComponent();

			hierarchyItem = new HierarchyItem("", TextField[0].getText(), TextField[1].getText());
			childNode = new DefaultMutableTreeNode(hierarchyItem);
			treeModel.insertNodeInto(childNode, (MutableTreeNode )treeNode, treeNode.getChildCount());
			HierTree.expandPath(treePath);
			HierTree.makeVisible(treePath);
		   }
		});
		Buttons[1].addMouseListener(new MouseAdapter() {		// Move Up
		   public void mouseClicked(MouseEvent e) {
// System.out.println(((JButton )e.getComponent()).getText());
			treePath = HierTree.getSelectionPath();
			if (treePath == null)
			   return;
			else
			   treeNode = (DefaultMutableTreeNode )treePath.getLastPathComponent();

			parentNode = treeNode.getParent();
			i = parentNode.getIndex(treeNode);
// System.out.println("isLeaf = " + treeNode.isLeaf() + ":" + parentNode.getChildCount() + ":" + i);
			if (parentNode.getChildCount() > 1 && i > 0) {
			   treeModel.insertNodeInto((MutableTreeNode )treeNode, (MutableTreeNode )parentNode, i - 1);
			   treeModel.nodeStructureChanged(parentNode);
			}
		   }
		});
		Buttons[2].addMouseListener(new MouseAdapter() {		// Move Down
		   public void mouseClicked(MouseEvent e) {
// System.out.println(((JButton )e.getComponent()).getText());
			treePath = HierTree.getSelectionPath();
			if (treePath == null)
			   return;
			else
			   treeNode = (DefaultMutableTreeNode )treePath.getLastPathComponent();

			parentNode = treeNode.getParent();
			i = parentNode.getIndex(treeNode);
// System.out.println("isLeaf = " + treeNode.isLeaf() + ":" + parentNode.getChildCount() + ":" + i);
			if (parentNode.getChildCount() > 1 && i < parentNode.getChildCount() - 1) {
			   treeModel.insertNodeInto((MutableTreeNode )treeNode, (MutableTreeNode )parentNode, i + 1);
			   treeModel.nodeStructureChanged(parentNode);
			}
		   }
		});
		Buttons[3].addMouseListener(new MouseAdapter() {		// Remove
		   public void mouseClicked(MouseEvent e) {
// System.out.println(((JButton )e.getComponent()).getText());
		     TreePath currentSelection = HierTree.getSelectionPath();
		     if (currentSelection != null) {
		         DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
		                    (currentSelection.getLastPathComponent());
		         MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
		         if (parent != null) {
		           treeModel.removeNodeFromParent(currentNode);
		           return;
		         }
		     } 
		   }
		});
		Buttons[4].addMouseListener(new MouseAdapter() {		// Generate
		   public void mouseClicked(MouseEvent e) {
// System.out.println(((JButton )e.getComponent()).getText());
			traverseTree(rootNode, "");
		   }
		});
		Buttons[5].addMouseListener(new MouseAdapter() {		// Load
		   public void mouseClicked(MouseEvent e) {
// System.out.println(((JButton )e.getComponent()).getText());
		   }
		});
		Buttons[6].addMouseListener(new MouseAdapter() {		// Save
		   public void mouseClicked(MouseEvent e) {
// System.out.println(((JButton )e.getComponent()).getText());
		   }
		});

		getContentPane().add(ScrollPane);
		getContentPane().add(Panel);

		invalidate();
		validate();
		repaint();
	}

	public void traverseTree(DefaultMutableTreeNode node, String Key) {
System.out.println(Key + " -> " + node);
		for (int i=0; i < treeModel.getChildCount(node); i++) {
			traverseTree((DefaultMutableTreeNode )treeModel.getChild(node, i), Key + (10 + i));
		}
	}

	public Frame getFrame() {
      	   Container parent = this;
      		for (; parent != null && !(parent instanceof Frame);
			parent = parent.getParent());
      		if (parent != null)
			return (Frame)parent;
      		else
			return null;
	}

	public void setScreenPosition() {
       	   Dimension dim = getToolkit().getScreenSize();
           Rectangle abounds = getBounds();
       	   Dimension dd = getSize();

        	HierParent.setLocation((dim.width - abounds.width) / 2,
        	     (dim.height - abounds.height) / 2);
    		requestFocus();
	}

	public void setCenter(Component parent, Component child) {
		Dimension pdim = parent.getSize();
		Point ppt = parent.getLocationOnScreen();
		Dimension cdim = child.getSize();
		child.setLocation(ppt.x + (pdim.width - cdim.width)/2,
			ppt.y + (pdim.height - cdim.height)/2);
	}

	public static void main(String args[]) {

		JFrame fHier = new JFrame("A Hierarchy Editor");
		fHier.addWindowListener(new WindowAdapter() {
		   public void windowClosing(WindowEvent e) {
			System.exit(0); 
		   }
		});

		HierApplet aHier = new HierApplet();
		fHier.getContentPane().add(aHier);
		fHier.setSize(SCREEN_X,SCREEN_Y);
		fHier.show();

		aHier.init();
		aHier.start(args);
	}
}
